<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 4.9: Initialization</title>
<link href="sx7h.html" rev=precedes>
<link href="sx7j.html" rel=precedes>
<link href="sx7.html" rev=subdocument>
</head>
<body>
<H2>section 4.9: Initialization</H2>

page 85
<p>These are <em>some</em> of the rules on initialization;
we'll learn a few more later
as we learn about a few more data types.
</p><p>If you don't feel like memorizing the rules for default initialization,
just go ahead and explicitly initialize everything you care about.
</p><p>Earlier we said that C is quite general in its treatment of expressions:
anywhere you can use an expression,
you can use any expression.
Here's an exception to that rule:
in an initialization of an external or static variable
(strictly speaking, any variable of static duration;
generally speaking, any global variable
or local <TT>static</TT> variable),
the initializer must be a constant expression,
with value determinable at compile time,
without calling any functions.
(This rule is easy to understand:
since these initializations
happen 
conceptually at compile time,
before the program starts running,
there's no way for a function call--that is,
some run-time action--to be involved.)
</p><p>page 86
</p><p>It probably won't concern you right away,
but it turns out that there's another exception
about the allowable expressions in initializers:
in the brace-enclosed list of initializers for an array,
all of the expressions must be constant expressions
(even for local arrays).

</p><p>There is an error in some printings:
if there are fewer explicit initializers than required for an array,
the others will be initialized to zero,
for external, static, <em>and</em> automatic (local) arrays.
(When an automatic array has no initializers at all,
then it contains garbage,
just as simple automatic variables do.)
</p><p>If the initialization
<pre>	char pattern[] = "ould";
</pre>makes sense to you, you're fine.
But if the statement that
<pre>	char pattern[] = "ould";
</pre>is equivalent to
<pre>	char pattern[] = { 'o', 'u', 'l', 'd', '\0' };
</pre>bothers you at all,
study it until it makes sense.
Also, note that a character array which seems to contain
(for example)
four characters
actually contains five, because of the terminating <TT>'\0'</TT>.
</p><hr>
<p>
Read sequentially:
<a href="sx7h.html" rev=precedes>prev</a>
<a href="sx7j.html" rel=precedes>next</a>
<a href="sx7.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
